using System;
using Inetlab.MMS;
using MM7ClientDemo.Controls;

namespace MM7ClientDemo
{
    public class MM7ClientCreator
    {
        private readonly IClientSettings _settings;

        public MM7ClientCreator(IClientSettings settings)
        {
            _settings = settings;
        }

        public MM7Client Create()
        {
            if (string.IsNullOrEmpty(_settings.Url))
            {
                throw new ArgumentException("Please specify MMSC/VASP Server url.");
            }

            MM7Client client = new MM7Client(_settings.Url);

            //please specify MM7 version required for MMSC
            client.MM7Version = "6.8.0";
            client.AuthId = _settings.AuthID;
            client.AuthSecret = _settings.AuthPassword;
            client.VASPID = _settings.VASPID;
            client.VASID = _settings.VASID;
            client.SenderAddress = _settings.SenderAddress;
            client.ServiceCode = _settings.ServiceCode;


            // Use proxy if it is specified
            if (!string.IsNullOrEmpty(_settings.ProxyUrl))
            {
                client.Proxy = new System.Net.WebProxy(_settings.ProxyUrl);
            }

            return client;
        }

 
    }
}