﻿using System.IO;
using System.Threading.Tasks;
using Inetlab.MMS;
using Inetlab.MMS.MM7;

namespace MM7ServerDemo
{

    /// <summary> Server events for MMSC</summary>
    internal class MMSCEvents : MM7ServerEvents
    {
        public override Task<string> Authentication(AuthenticationEventArgs args)
        {
            string password = args.UserName;

            return Task.FromResult(password);
        }

        public override Task<SubmitResponse> SubmitRequest(SubmitReqEventArgs e)
        {
            string textId = e.Context.Request.Url.QueryParameter("TextId");

            // Save all MMS message parts to the SubmitRequest folder
            string path = Path.GetFullPath("SubmitRequest");
            path = Path.Combine(path, e.Request.TransactionID);
            Directory.CreateDirectory(path);

            foreach (MMSPart part in e.Message.Parts)
            {
                part.Save(Path.Combine(path, part.GetFileName()));
            }


            return Task.FromResult(new SubmitResponse(e.Request));
        }
    }
}