﻿using System.IO;
using System.Threading.Tasks;
using System.Web;
using Inetlab.MMS;
using Inetlab.MMS.MM7;

namespace MMSServer.ASPNET
{
    // ReSharper disable once InconsistentNaming
    public class mms : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            MM7Server server = new MM7Server();
            // server.AuthScheme = AuthenticationSchemes.Basic;
            server.Events.OnAuthentication += OnAuthentication;
            server.Events.OnSubmitRequest += OnSubmitRequest;
            server.Events.OnDeliverRequest += OnDeliverRequest;
            server.ProcessRequest(new TestHttpContextWrapper(context));
        }

        private Task<string> OnAuthentication(AuthenticationEventArgs args)
        {
            string password = args.UserName;

            return Task.FromResult(password);
        }

        Task<SubmitResponse> OnSubmitRequest(SubmitReqEventArgs e)
        {

            string appData = HttpContext.Current.Server.MapPath("App_Data");
            string submitRequestFolder = Path.Combine(appData, "SubmitRequest");


            // Save all MMS message parts to the SubmitRequest folder
            string path = Path.Combine(submitRequestFolder, e.Message.Header.TransactionId);
            Directory.CreateDirectory(path);
            foreach (MMSPart part in e.Message.Parts)
            {
                part.Save(Path.Combine(path, part.GetFileName()));
            }

            var response = new SubmitResponse(e.Request);

            response.Status = ResponseStatus.OK;

            return Task.FromResult(response);
        }

        Task<DeliverResponse> OnDeliverRequest(DeliverReqEventArgs e)
        {

            string appData = HttpContext.Current.Server.MapPath("App_Data");
            string deliverRequestFolder = Path.Combine(appData, "DeliverRequest");


            // Save all MMS message parts to the Delivered folder
            string path = Path.Combine(deliverRequestFolder, e.Message.Header.TransactionId);
            Directory.CreateDirectory(path);

            //sender phone number
            //string from = e.Request.Sender.Number;

            foreach (MMSPart part in e.Message.Parts)
            {
                part.Save(Path.Combine(path, part.GetFileName()));
            }

            var response = new DeliverResponse(e.Request);

            response.Status = ResponseStatus.OK;

            return Task.FromResult(response);
        }


        public bool IsReusable => false;
    }
}