﻿using System;
using System.Threading.Tasks;
using Inetlab.MMS;
using Microsoft.AspNetCore.Http;

namespace MMSServer.ASPNETCore
{
    public class MM7EndpointMiddleware
    {
        private readonly RequestDelegate _next;
        private readonly PathString _path;
        private readonly MM7Server _server;

        public MM7EndpointMiddleware(RequestDelegate next, PathString path, MM7ServerEvents events)
        {
            _next = next;
            _path = path;

            _server= new MM7Server();
            _server.Events = events;
           
        }

        public async Task Invoke(HttpContext httpContext, IServiceProvider serviceProvider)
        {
            if (httpContext.Request.Path.Equals(_path, StringComparison.Ordinal))
            {
                await _server.ProcessRequestAsync(new HttpContextWrapper(httpContext));
            }
            else
            {
                await _next(httpContext);
            }
        }
    }
}